/* 
 * The Behavior Control Panel GuiMaker
 * by Ajay Kulkarni
 * 01.11.2002
 *
 */

package agentland.behavior;

import metaglue.*;
import java.rmi.*;
import agentland.gui.*;
import agentland.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class BCPGuiMaker extends GuiMaker {
    protected JLayeredPane topPane;
    protected JSplitPane mainPanel;
    protected JSplitPane subPanel;

    //    private JLabel regBevsLabel;

    // for (all) registered behaviors pane
    private JList regBevsList;
    private JList eventsList;
    private JList activatingEventsList;
    private JList actionsList;
    private JList parentsList;

    // for specific behaviors pane
    private JList actBevsList;
    //    private JList actParsList;
    private JList leafBevsList;
    //    private JList leafParsList;
    private JList lisBevsList;
    //    private JList lisActList;
    private JList inactBevsList;
    //    private JList 
    


    private BehaviorCoordinator bevcoord;
    private Vector regBevs;
    private BehaviorID selectedBevID;
    private Hashtable bevIDToBevHash;

    public BCPGuiMaker(String name, AgentID parent) {
	super(name, parent);
	bevIDToBevHash = new Hashtable();

	regBevsList = new JList();
	actBevsList = new JList();
	leafBevsList = new JList();
	lisBevsList = new JList();
	inactBevsList = new JList();

	eventsList = new JList();
	actionsList = new JList();
	activatingEventsList = new JList();
	parentsList = new JList();
	
	//	subPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
	//	mainPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);

    }

    public void init() {
	// do all reliesOn and addSpy commands here
	bevcoord = (BehaviorCoordinator) reliesOn("agentland.behavior.BehaviorCoordinator");
	//	addSpy("behavior.gui.update", "update");
	addSpy("behavior.gui.update");
    }

    public Container getGui() {
	//	bevcoord = (BehaviorCoordinator) reliesOn("agentland.behavior.BehaviorCoordinator");

	// the gut of the gui
	//	topPane = new JLayeredPane();
	//	mainPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
	subPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
	mainPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);

	subPanel.add(getBevsPane());
	subPanel.add(getBevsInfoPane());
	
	mainPanel.add(subPanel);
	mainPanel.add(getSpecBevsPane());

	//	mainPanel.add(getBevsPane());
	//	mainPanel.add(getBevsInfoPane());
	//	topPane.add(mainPanel, JLayeredPane.DEFAULT_LAYER);
	
	//	return topPane;
	return mainPanel;
    }

    public void tell(Secret s) {
	if (s.isA("behavior.gui.update"))
	    update();
    }

    private void update() {
	try {
	    regBevsList.setListData(bevcoord.getRegBevs());
	    leafBevsList.setListData(bevcoord.getLeafBevs());
	    actBevsList.setListData(bevcoord.getActiveBevs());
	    lisBevsList.setListData(bevcoord.getListeningBevs());
	    inactBevsList.setListData(bevcoord.getInactiveBevs());
	} catch(Exception ex) {
	    log("ERROR", "Error getting behaviors from Behavior Coordinator: " + ex);
	}
	//	mainPanel.revalidate();
	//	mainPanel.update();
	/*
	updateList(regBevsList); 
	updateList(leafBevsList);
	updateList(actBevsList); 
	updateList(lisBevsList); 
	updateList(inactBevsList);
	*/
    }

    // IGNORE for now...
    private void updateList(JList jl) {
	jl.revalidate();
	//	jl.update();
    }


    private Container getBevsPane() {
	JPanel bPane = new JPanel(new BorderLayout());

	try {
	    regBevs = bevcoord.getRegBevs();

	    //	    regBevsList = new JList(regBevs);
	    regBevsList.setListData(regBevs);
	    JLabel regBevsLabel = new JLabel("Registered Behaviors:");

	    bPane.add(regBevsLabel, BorderLayout.NORTH);
	    bPane.add(new JScrollPane(regBevsList), BorderLayout.CENTER);

	} catch(Exception e) {
	    log("ERROR", "Error getting the behaviors pane: " + e);
	}

	regBevsList.addMouseListener(new MouseAdapter() {
		public void mousePressed(MouseEvent e) {
		    selectedBevID = (BehaviorID) regBevsList.getSelectedValue();
		    if (selectedBevID != null) {
			Behavior bev = (Behavior)bevIDToBevHash.get(selectedBevID);
			if (bev == null) {
			    bev = (Behavior)reliesOn(selectedBevID.getAgentID());
			    bevIDToBevHash.put(selectedBevID, bev);
			}
			try {
			    eventsList.setListData(bev.getAllEvents());
			    actionsList.setListData(bev.getActionNames());
			    activatingEventsList.setListData(bev.getActivationEvents());
			    parentsList.setListData(bev.getParents());
			} catch (RemoteException ex) {
			    log("ERROR", "Error setting List Data: " + ex);
			}
		    } 
		}
	    });
	
	return bPane;
    }
	

    private Container getBevsInfoPane() {
	JPanel ePane = new JPanel();
	JPanel pPane = new JPanel();
	JPanel aPane = new JPanel();
	JPanel aePane = new JPanel();
	
	try {
	    /*
	    Enumeration bevs = regBevs.elements(); 
	    while (bevs.hasNext()) { 
		BehaviorID bevID = (BehaviorID)bevs.next(); 
		if (bevIDToBevHash.get(bevID) == null)  
		    bevIDToBevHash.put(bevID, (Behavior)reliesOn(bevID.getAgentID())); 
		Behavior bev = (Behavior)bevIDToBevHash.get(bevID); 
	    */
	    /*
	    selectedBevID = (BehaviorID) regBevsList.getSelectedValue(); 
	    if (selectedBevID != null) { 
		Behavior bev = (Behavior)bevIDToBevHash.get(selectedBevID); 
		if (bev == null) { 
		    bev = (Behavior)reliesOn(selectedBevID.getAgentID()); 
		    bevIDToBevHash.put(selectedBevID, bev); 
		} 
		//		eventsList = new JList(bev.getAllEvents());
		eventsList.setListData(bev.getAllEvents()); 
		parentsList.setListData(bev.getParents()); 
		log("PARENTES: " + bev.getParents()); 
		// actionsList.set
		} */

	    // not sure if the scroll panes below work... but don't
	    // have enough items to check
	    //	    ePane.add(new JScrollPane(eventsList));
	    aePane.add(new JScrollPane(activatingEventsList));
	    aPane.add(new JScrollPane(actionsList));
	    pPane.add(new JScrollPane(parentsList));
	    
	    	    

	} catch(Exception e) {
	    log("ERROR", "Error getting the info pane: " + e);
	}
	//	return ePane;
	
	JTabbedPane tabPane = new JTabbedPane();
	//	tabPane.addTab("Events", ePane);
	tabPane.addTab("Events", new JScrollPane(eventsList));
	tabPane.addTab("Activating Events", aePane);
	tabPane.addTab("Actions", aPane);
	tabPane.addTab("Parents", pPane);


	return tabPane;
    }
		
    // specific bevs panel
    private Container getSpecBevsPane() {
	JPanel sBPane = new JPanel(new GridLayout(2,2));
	sBPane.add(getLeafBevsPane());
	sBPane.add(getActiveBevsPane());
	sBPane.add(getListeningBevsPane());
	sBPane.add(getInactiveBevsPane());
	return sBPane;
    }


    // subpanels for specific bevs panel
    private Container getLeafBevsPane() {
	JPanel leBPane = new JPanel(new BorderLayout());
	try {
	    leafBevsList.setListData(bevcoord.getLeafBevs());
	    leBPane.add(new JLabel("Leaf Behaviors"), BorderLayout.NORTH);
	    leBPane.add(new JScrollPane(leafBevsList), BorderLayout.CENTER);
	} catch(RemoteException ex) {
	    log("ERROR", "Error getting leaf bevs: " + ex);
	}
	return leBPane;
    }
    
    private Container getActiveBevsPane() {
	JPanel aBPane = new JPanel(new BorderLayout());
	try {
	    actBevsList.setListData(bevcoord.getActiveBevs());
	    aBPane.add(new JLabel("All Active Behaviors"), BorderLayout.NORTH);
	    aBPane.add(new JScrollPane(actBevsList), BorderLayout.CENTER);
	} catch (RemoteException ex) {
	    log("ERROR", "Error getting active bevs: " + ex);
	}
	return aBPane;
    }
    
    private Container getListeningBevsPane() {
	JPanel liBPane = new JPanel(new BorderLayout());
	try {
	    lisBevsList.setListData(bevcoord.getListeningBevs());
	    liBPane.add(new JLabel("Listening Behaviors"), BorderLayout.NORTH);
	    liBPane.add(new JScrollPane(lisBevsList), BorderLayout.CENTER);
	} catch (RemoteException ex) {
	    log("ERROR", "Error getting listening bevs: " + ex);
	}
	return liBPane;
    }

    private Container getInactiveBevsPane() {
	JPanel iBPane = new JPanel(new BorderLayout());
	try {
	    inactBevsList.setListData(bevcoord.getInactiveBevs());
	    iBPane.add(new JLabel("Inactive Behaviors"), BorderLayout.NORTH);
	    iBPane.add(new JScrollPane(inactBevsList), BorderLayout.CENTER);
	} catch (RemoteException ex) {
	    log("ERROR", "Error getting inactive bevs: " + ex);
	}
	return iBPane;
    }

    




    /************************************************************/
    /**** IGNORE FOR NOW ****/
    // inner class for drawing lines
    private class LineLabel extends JPanel {
	private int x1;
	private int x2;
	private int y1;
	private int y2;

	final Color fg = Color.black;
	final Color bg = Color.white;

	public LineLabel(int x_from, int y_from, int x_to, int y_to) {
	    super();

	    // initialize position and length of line
	    x1 = x_from;
	    x2 = x_to;
	    y1 = y_from;
	    y2 = y_to;

	    setBackground(bg);
	    setForeground(fg);
		
	    setBorder(BorderFactory.createCompoundBorder
		      (BorderFactory.createRaisedBevelBorder(),
		       BorderFactory.createLoweredBevelBorder()));

	}

	public void paintComponent(Graphics g) {
	    super.paintComponent(g); // clears background
	    
	    //	    Graphics2D g2d = (Graphics2D) g;

	    g.drawLine(x1,y1,x2,y2);

	    //	    g2d.draw(new Rectangle(0, 0, 400, 400));
	    g.drawRect(0,0,400,400);
	}
    }
    
    
}
