/**
 * Created by Ajay Kulkarni 6.11.2001
 *
 *
 */

package agentland.behavior;

import metaglue.*;
import java.rmi.*;
import java.util.*;
import agentland.resource.*;
import agentland.util.*;


/**
 * See the comments for <code>BehaviorAgent</code>.
 *
 * @see BehaviorAgent
 * @see Managed
 */
public interface Behavior extends Managed {

    public BehaviorID getID() throws RemoteException ;
    
    public void setIDNumeric(Integer num) throws RemoteException ;

    public boolean isOverriden() throws RemoteException ;

    public boolean isLeaf() throws RemoteException ; 

    public boolean isActive() throws RemoteException ;

    public boolean isListening() throws RemoteException ;
    
    public boolean isInactive() throws RemoteException ;

    public void addParent(BehaviorID bID) throws RemoteException ;

    public void addChild(BehaviorID bID) throws RemoteException ;

    public void removeChild(BehaviorID bID) throws RemoteException ;
    
    public Vector getParents() throws RemoteException ;

    public Vector getActiveParents() throws RemoteException ;

    public Vector getDirectActiveParents() throws RemoteException ; 

    public Vector getChildren() throws RemoteException ;

    public void activateParent(BehaviorID bID) throws RemoteException ;

    public void deactivateParent(BehaviorID bID) throws RemoteException ;

    public Vector getActionNames() throws RemoteException ; 

    public void addActionDependency(BehaviorID parID, String thisAction, String parentAction) throws RemoteException ;

    public void deleteActionDependency(BehaviorID parID, String thisAction, String parentAction) throws RemoteException ;

    public void overrideAction(String actionName) throws RemoteException ;

    public void activateAction(String actionName) throws RemoteException ;

    public void temporarilyActivateAction(String actionName) throws RemoteException ;
	
    public void override(Vector actionNames) throws RemoteException ;

    public void undoOverride(Vector actionNames) throws RemoteException ;

    public Vector getOverridenActions() throws RemoteException ;

    public Vector getEvents() throws RemoteException ;

    public Vector getActivationEvents() throws RemoteException ;
    
    public Vector getAllEvents() throws RemoteException ;

    public void pass(Secret secret) throws RemoteException ;

    public String getName() throws RemoteException ; 

    public String getDependencies(BehaviorID parID) throws RemoteException ;

    public String getDependencies() throws RemoteException ;

    public void registerBevCoord(AgentID aid) throws RemoteException ;

    public String showHashedAgentStubs() throws RemoteException ; 

    public void addPermanentAction(String actionName) throws RemoteException ;

    public void removePermanentAction(String actionName) throws RemoteException ;

    public Vector getPermanentActions() throws RemoteException ;

    public String getMainAlias() throws RemoteException ;

    public Vector getAliases() throws RemoteException ;
}
