/**
 * Created by Ajay Kulkarni 6.11.2001
 *
 *
 */

package agentland.behavior;

import metaglue.*;
import java.rmi.*;
import java.util.*;
import agentland.resource.*;


/**
 * See the comments for <code>BehaviorCoordinatorAgent</code>.
 *
 * @see BehaviorCoordinatorAgent
 * @see Managed
 */
public interface BehaviorCoordinator extends Managed {

    public void addBev(BehaviorID bid) throws RemoteException ;

    public String getBevNames() throws RemoteException ;

    public String getActiveBevNames() throws RemoteException ;

    public String getInactiveBevNames() throws RemoteException ;

    public String getListeningBevNames() throws RemoteException ;

    public String getTree() throws RemoteException ;

    public String getEvents() throws RemoteException ;

    public boolean isBevActive(BehaviorID bevID) throws RemoteException ;

    public void updateBev(BehaviorID bevID, int oldstate, int newstate) throws RemoteException ;

    public Vector getRegBevs() throws RemoteException ;
    
    public Vector getLeafBevs() throws RemoteException ;

    public Vector getActiveBevs() throws RemoteException ;

    public Vector getListeningBevs() throws RemoteException ;

    public Vector getInactiveBevs() throws RemoteException ;

}
