package agentland.behavior;
import java.rmi.*;
import metaglue.*;
import metaglue.AgentPrimer.*;

public class BehaviorCoordinatorEHA implements ExceptionHandler,agentland.behavior.BehaviorCoordinator,agentland.resource.Managed
{
	private AgentExceptionHandler aeh;
	private BehaviorCoordinator agent;
	private AgentID agentID;
	private MetagluePrimitives mp;
	public BehaviorCoordinatorEHA(MetagluePrimitives ap,AgentID agentID,Catalog c) throws RemoteException
	{
		aeh=new AgentExceptionHandler(ap,agentID,c);
		mp=ap;
		this.agentID=agentID;
		instantiate(null);
	}
	public Agent getAgent()
	{
		return (Agent)agent;
	}
	public void setAgent( Agent a )
	{
		agent = (BehaviorCoordinator)a;
	}
	public AgentID getAgtID()
	{
		return agentID;
	}
	public void setAgtID( AgentID a )
	{
		agentID = a;
	}
	public void instantiate(Agent a)
	{
		agent=(BehaviorCoordinator)a;
	}
	public void replaceExceptionHandler(AgentExceptionHandler r)
	{
		aeh=r;
	}
public  void shutdown( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.shutdown();
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"shutdown");}
		}
		while(repeat==true);
	}
	public AgentID getAgentID()
	{
		return agentID;
	}
public  boolean alive( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				boolean rv = agent.alive();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"alive");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  void startup( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.startup();
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"startup");}
		}
		while(repeat==true);
	}
public  metaglue.AgentID getMetaglueAgentID( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				metaglue.AgentID rv = agent.getMetaglueAgentID();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getMetaglueAgentID");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.net.InetAddress whereAreYou( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.net.InetAddress rv = agent.whereAreYou();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"whereAreYou");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  void addMonitor( metaglue.AgentID param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.addMonitor(param0);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"addMonitor");}
		}
		while(repeat==true);
	}
public  java.util.List getOldLogs( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.List rv = agent.getOldLogs();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getOldLogs");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  void tell( agentland.util.Secret param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.tell(param0);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"tell");}
		}
		while(repeat==true);
	}
public  java.util.Vector getHistory( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.Vector rv = agent.getHistory();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getHistory");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.lang.String getHistoryElement( int param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.lang.String rv = agent.getHistoryElement(param0);
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getHistoryElement");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  void resetHistory( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.resetHistory();
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"resetHistory");}
		}
		while(repeat==true);
	}
public  void replace( agentland.resource.Resource param0,agentland.resource.Resource param1) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.replace(param0,param1);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"replace");}
		}
		while(repeat==true);
	}
public  void replace( java.lang.String param0,java.lang.String param1,agentland.resource.Resource param2) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.replace(param0,param1,param2);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"replace");}
		}
		while(repeat==true);
	}
public  void yank( agentland.resource.ResourceBunch param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.yank(param0);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"yank");}
		}
		while(repeat==true);
	}
public  void yank( java.lang.String param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.yank(param0);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"yank");}
		}
		while(repeat==true);
	}
public  agentland.resource.Need getNeed( java.lang.String param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agentland.resource.Need rv = agent.getNeed(param0);
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getNeed");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.util.Vector resources( util.Filter param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.Vector rv = agent.resources(param0);
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"resources");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  void addBev( agentland.behavior.BehaviorID param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.addBev(param0);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"addBev");}
		}
		while(repeat==true);
	}
public  java.lang.String getBevNames( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.lang.String rv = agent.getBevNames();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getBevNames");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.lang.String getTree( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.lang.String rv = agent.getTree();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getTree");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.lang.String getEvents( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.lang.String rv = agent.getEvents();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getEvents");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  boolean isBevActive( agentland.behavior.BehaviorID param0) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				boolean rv = agent.isBevActive(param0);
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"isBevActive");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  void updateBev( agentland.behavior.BehaviorID param0,int param1,int param2) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				agent.updateBev(param0,param1,param2);
				aeh.goodCall();
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"updateBev");}
		}
		while(repeat==true);
	}
public  java.util.Vector getLeafBevs( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.Vector rv = agent.getLeafBevs();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getLeafBevs");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.util.Vector getActiveBevs( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.Vector rv = agent.getActiveBevs();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getActiveBevs");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.util.Vector getListeningBevs( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.Vector rv = agent.getListeningBevs();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getListeningBevs");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
public  java.util.Vector getInactiveBevs( ) throws java.rmi.RemoteException
	{
		boolean repeat;
		if(agent==null)
		{
			instantiate(mp.reliesOnSynch(agentID));
		}
		do
		{
			try
			{
				repeat=false;
				java.util.Vector rv = agent.getInactiveBevs();
				aeh.goodCall();
				return rv;
			}
			catch(RemoteException e) {repeat=aeh.handleRemoteException(e,this,"getInactiveBevs");}
		}
		while(repeat==true);
		throw new RemoteException();
	}
}
