/**
 * Created by Ajay Kulkarni 6.12.2001
 *
 *
 */

package agentland.behavior;

import java.io.*;
import metaglue.*;

public class BehaviorID implements Serializable {

    private int numeric;
    private AgentID agID;

    public BehaviorID(AgentID ag) {
	numeric = -1;
	agID = ag;
    }

    public Integer getNumeric() {
	return new Integer(numeric);
    }

    public void setNumeric(Integer num) {
	numeric = num.intValue();
    }

    public AgentID getAgentID() {
	return agID;
    }

    // returns actual behavior name
    // i.e., for agent "agentland.behavior.ABCBehavior"
    // it returns "ABCBehavior"
    // (that is, returns the substring of the occupation AFTER the
    // last period.) 
    public String getName() { 
	int i = agID.getOccupation().lastIndexOf('.');
	return agID.getOccupation().substring(i+1);
	

	//	return agID.getOccupation().substring(19);
    }
    
    public String toString() {
	return "(" + numeric + "," + agID.getOccupation() + ")";
    }

    public boolean equals(Object obj) {
	if (obj instanceof BehaviorID) {
	    BehaviorID bevID = (BehaviorID) obj;
	    if (bevID.getAgentID().equals(agID))
		return true;
	    else
		return false;
	}
	else 
	    return false;
    }

    /**
     * The method <code>hashCode</code> is necessary to be able
     * to use BehaviorIDs as keys in hashtables. The reason for this
     * is similar to the reason for having a special equals() method for
     * BehaviorIDs: passing BehaviorIDs around doesn't quite send the
     * same object around. The hash function used in a table will assign
     * two different values to these different objects, ALTHOUGH they are 
     * they same BehaviorID.
     *
     * The hash code returned is the numeric value for the BehaviorID. Note
     * that this is a good hash function, as the numeric value is unique
     * for a given BehaviorID. (The BehaviorCoordinator ensures this uniqueness.)
     *
     * @return the hash value as an <code>int</code> 
     */
    public int hashCode() {
	return numeric;
    }
    
}

    
