/**
 * Created by Ajay Kulkarni 11.26.01
 */

package agentland.behavior;

import metaglue.*;
import java.rmi.*;
import agentland.device.display.*;
import agentland.util.*;

public class MapSystemBehaviorAgent extends BehaviorAgent 
    implements MapSystemBehavior {

    // make the following item false before checking in 
    // (only true for testing in rooms w/out projectors)
    private boolean TEST = true;

    private Projector projector1;
    private Projector projector2;

    
    // needs to call super(); bfore running any other code
    // so that actions get registered
    public MapSystemBehaviorAgent() throws RemoteException {
	super();
	setLogLevel(LogStream.DEBUG);
	addAlias("Map System Mode");

	if (!TEST) {
	    projector1 = (Projector) reliesOn("agentland.device.display.Projector","4");
	    projector2 = (Projector) reliesOn("agentland.device.display.Projector","2");
	}

	addEvent("behavior.mapsystem.start", "activate");
	addEvent("behavior.mapsystem.stop", "actionDeactivate");

	/**** voice recog section ****/
	addGrammar("agentland.behavior.speechin.mapsystemBehavior");
       
	// start map voice recog
	addKeyNotePair("startmap","behavior.mapsystem.start");

	// stop map voice recog
	addKeyNotePair("stopmap","behavior.mapsystem.stop");
	/****************************/
    }

    // needs to call makeActive() when it is activated
    public void activate(Secret secret) {
	if (secret.isA("behavior.mapsystem.start")) {
	    try {
		makeActive(); // tell bev coord that you are now active

		if (!TEST) {
		    // setting up the projectors
		    projector1.turnOn();
		    projector2.turnOn();
		    projector1.inputRGB1();
		    projector2.inputRGB1();
		}
		
		bevSay("DEBUG","Map System Started");
		log("DEBUG","MapBev is now active");
	    } catch(Exception e) {
		log("ERROR", "Error while trying to activate MapSystemBehavior: " + e);
	    }
	}
    }

    // needs to call makeListening(); when it is deactivated
    public void actionDeactivate(Secret secret) {
	if (secret.isA("behavior.mapsystem.stop")) {
	    makeListening(); // tell bev coord that you are no longer active
	    bevSay("DEBUG","Map System Ended");
	    log("DEBUG","MapBev is now not active");
	} 
    }
}
		
		




