/**
 * Created by Ajay Kulkarni 1.24.2002
 * 
 */

package agentland.behavior;

import metaglue.*;
import java.rmi.*;
import agentland.util.*;
import agentland.device.light.*;

public class OccupiedBehaviorAgent extends BehaviorAgent
    implements OccupiedBehavior {

    private LightManager lights;

    public OccupiedBehaviorAgent() throws RemoteException {
	super();
	setLogLevel(LogStream.DEBUG);
	addAlias("Occupied Mode");

	// devices
	lights = (LightManager) reliesOn("agentland.device.light.LightManager");
	
	// speech
	addGrammar("agentland.behavior.speechin.occupiedBehavior");
	addKeyNotePair("startocc","behavior.occupied.start");
	addKeyNotePair("stopocc","behavior.occupied.stop");

	// events to listen for
	addEvent("behavior.occupied.start","activate");
	addEvent("behavior.occupied.stop","actionDeactivate");
	// add "room occupied event" here
	// add "room vacant event" here
	
    }

    // method needs to call makeActive();
    public void activate(Secret secret) {
	makeActive();

	// turns lights on if occupied

	bevSay("DEBUG","Occupied Behavior Started");
	log("DEBUG", "Occupied Behavior is now active");
    }

    // method needs to call makeListening();
    public void actionDeactivate(Secret secret) {
	makeListening();

	// turns lights off if no longer occupied

	bevSay("DEBUG", "Occupied Behavior Started");
	log("DEBUG", "Occupied Behavior is no longer active");
    }
	
}
