/**
 * Created by Ajay Kulkarni 1.8.2002
 *
 */

package agentland.behavior;

import metaglue.*;
import java.rmi.*;
import agentland.util.*;
import agentland.device.light.*;

public class VacantBehaviorAgent extends BehaviorAgent implements VacantBehavior {

    private LightManager lights;

    public VacantBehaviorAgent() throws RemoteException {
	super();
	setLogLevel(LogStream.DEBUG);
	addAlias("Vacant Mode");

	// devices
	lights = (LightManager) reliesOn("agentland.device.light.LightManager");
	
	// speech section
	addGrammar("agentland.behavior.speechin.vacantBehavior");
	addKeyNotePair("startvacant","behavior.vacant.start");
	addKeyNotePair("stopvacant","behavior.vacant.stop");
	
	// add events here
	addEvent("behavior.vacant.start","activate");
	addEvent("behavior.vacant.stop","actionDeactivate");
	addEvent("perception.cloud.door open","actionLights");
    }


    // method needs to call makeActive() 
    public void activate(Secret secret) {
	makeActive();
	bevSay("DEBUG","Vacant Behavior Started");
	log("DEBUG", "VacantBev is now active");
    }

    // method needs to call makeListening() 
    public void actionDeactivate(Secret secret) {
	makeListening();
	bevSay("DEBUG","Vacant Behavior Stopped");
	log("DEBUG", "VacantBev is no longer active");
    }

    // add other actions here
    public void actionLights(Secret secret) {
	if (secret.isA("perception.cloud.door open")) {
	    try {
		lights.turnOn();
		log("DEBUG", "actionLights");
	    } catch(Exception e) {
		log("ERROR", "Error during Lights Action: " + e);
	    }
	}
    }
}
