package agentland.behavior.behaviors;

import agentland.behavior.*;
import agentland.device.light.*;
import agentland.util.asker.*;
import agentland.util.Secret; 
import java.rmi.RemoteException;
import metaglue.*;


public class Office804WelcomeBehaviorAgent extends BehaviorAgent
  implements Office804WelcomeBehavior {

  // the behavior AGENT file (i.e., the class) must:
  //      a) extend agentland.behavior.BehaviorAgent
  //      b) implement the behavior INTERFACE 
  //
  // the behavior INTERFACE must:
  //         extend agentland.behavior.Behavior
  
  protected LightManager lManager;
  protected MultimodalAsker mAsker;

  public Office804WelcomeBehaviorAgent () throws RemoteException {

    super(); 

    lManager = (LightManager) requestAgent( "agentland.device.light.LightManager" );
    mAsker = (MultimodalAsker) requestAgent( "agentland.util.asker.MultimodalAsker" );

    addEvent( "Magically detect someone entering room", 
	      "activate" );
    addEvent( "Magically detect office empty for n minutes",
	      "actionDeactivate" );

  } // constructor


  public void actionDoWelcome () {

  } // doWelcome


  /*** ACTIONS ***/ 
  public void activate ( Secret secret ) {

    makeActive(); 

    bevSay( "Welcome to office 804" );

    try {

      lManager.turnOn( "overhead lights" );

    } catch ( RemoteException eRemote ) {

    } // catch

  } // activate


  public void actionDeactivate ( Secret secret ) {

    try {
      
      int iAnswer = mAsker.ask( "Is anyone still here?", 10 );
      
      if ( iAnswer != GoodAsker.YES ) {
	
	makeListening();
	
	lManager.turnOff( "all the lights" );

      } // if

    } catch ( RemoteException eRemote ) {
      
    } // catch

  } // actionDeactivate


    public void actionLights(Secret secret) {
	//do nothing
	log("DEBUG", "Actionlights doing nothing");
    }
}











